from __future__ import division
import pygame, random
from pygame.locals import *

import gp2x
import os
import sys
from os.path import join, getsize

class Browser:
	def __init__(self):
		self.currentline=0
		self.linelimit=10
		self.directory=os.getcwd() 
		os.chdir(self.directory)
		self.dirlist=[]
		startpos=0
		endpos=self.linelimit
		self.extensions=[".bmp",".jpg",".png",".gif"]
			
		self.background = pygame.Surface((320,240))
		self.background = self.background.convert()
		self.background.fill(grey3)
		

	def draw(self,screen):
		self.dirlist=[]
		if os.getcwd()=="/":
				self.dirlist.append("[Top level]")
		else:
				self.dirlist.append("[..]")

		readdir=(os.listdir(self.directory))
		for p in range(0,len(readdir)):			# add dirs
			if not readdir[p][0]==".":
				if os.path.isdir(readdir[p]):
					self.dirlist.append(readdir[p])
		for p in range(0,len(readdir)):			# add files that have permitted extensions
			if not readdir[p][0]==".":
				if not os.path.isdir(readdir[p]):
						(shortname, extension) = os.path.splitext(readdir[p]) 
						if extension.lower() in self.extensions:
							self.dirlist.append(readdir[p])



		if self.currentline>5:
			self.startpos=self.currentline-5
		else:
			self.startpos=0
		self.endpos=self.startpos+self.linelimit
		if self.endpos>len(self.dirlist):
			self.endpos=len(self.dirlist)


		screen.blit(self.background, (0,0))
		msgsay(screen,self.directory,16,grey1,10,10,"left")
		msgsay(screen,"[B]=Click  [Select]=Preview  [Start]=Cancel",20,grey1,10,220,"left")

		for position in range(self.startpos,self.endpos):
		
			if position==self.currentline:
				textcolour=red
			else:
				textcolour=black
		
			if os.path.isdir(self.dirlist[position]):
				mk=["[","]"]
			else:
				mk=["",""]		
			msgsay(screen,mk[0]+self.dirlist[position]+mk[1],20,textcolour,10,25+(18*(position-self.startpos)),"left")
   		pygame.display.flip()		



def msgsay(screen,text,fontsize,colour,x,y,justify):
        font = pygame.font.Font(None, fontsize)
        text = font.render(text, 0, colour)
       	textpos = text.get_rect()
	if justify=="right":
		textpos.topright = (x,y)
	else:
		textpos.topleft = (x,y)
	screen.blit(text, textpos)	


def drawmsgbox(screen,wide,high,x,y,col1,col2,border):
	back=pygame.Surface((wide,high))
	back=back.convert()
	back.fill(col1)
	screen.blit(back, (x,y))
	if wide>1 and high>1:
		back=pygame.Surface((wide-(border*2),high-(border*2)))
		back=back.convert()
		back.fill(col2)
		screen.blit(back, (x+border,y+border))	
			




def main():
	pygame.init()
	num_joysticks = pygame.joystick.get_count()
	if num_joysticks > 0:
		stick = pygame.joystick.Joystick(0)
		stick.init() # now we will receive events for the joystick
	pygame.mouse.set_cursor(*pygame.cursors.broken_x)
	global red,green,blue,white,black,grey1,grey2,grey3
	white = (255, 255, 255)
	black = (0, 0, 0)
	red = (255,0,0)
	green = (0,255,0)
	blue = (0,0,255)
	grey1= (63,63,63)
	grey2 = (127,127,127)
	grey3 = (191,191,191)
	size = width, height = 320,240
	screen = pygame.display.set_mode(size)
	pygame.display.set_caption('File browser')


	my_picture = pygame.Surface((320,240))
	my_picture = my_picture.convert()
	my_picture.fill(grey3)
	screen.blit(my_picture, (0,0))
	
	files=Browser()
	
	pygame.display.flip()
	
	files.draw(screen)
	

	
	while 1:
	

	
		for event in pygame.event.get():
			pressed_keys = pygame.key.get_pressed() 
			if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE ):
				return "NOTHING"
			if (event.type == KEYDOWN and pressed_keys[K_UP]) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_UP) or (event.type == pygame.JOYBUTTONDOWN and event.button == gp2x.BUTTON_UPLEFT) or (event.type == pygame.JOYBUTTONDOWN and event.button == gp2x.BUTTON_UPRIGHT):
				if files.currentline > 0:
					files.currentline += -1
					files.draw(screen)	


			if (event.type == KEYDOWN and pressed_keys[K_DOWN]) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_DOWN) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_DOWNLEFT) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_DOWNRIGHT) : 
				if files.currentline<len(files.dirlist)-1:
					files.currentline += 1
					files.draw(screen)	

			if (event.type == KEYDOWN and event.key==K_SPACE) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_B):
					print files.dirlist[files.currentline]
					if files.dirlist[files.currentline]=="[..]":
										
						os.chdir("..")
						files.directory=os.getcwd()
						files.currentline=0
						files.draw(screen)
					elif files.dirlist[files.currentline]=="[Top level]":
						ignore=1
					elif os.path.isdir(files.dirlist[files.currentline]):
						if files.directory=="/":
							files.directory=files.directory+files.dirlist[files.currentline]
						else:
							files.directory=files.directory+"/"+files.dirlist[files.currentline]

										
						os.chdir(files.directory)
						files.currentline=0
						files.draw(screen)
						
					else:
						return files.dirlist[files.currentline]
			
			if (event.type == KEYDOWN and event.key==K_q) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_START):
					return "NOTHING"
					
			if (event.type == KEYDOWN and event.key==K_b) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_SELECT):
				# preview

				if not ( (files.dirlist[files.currentline]=="[..]") or (files.dirlist[files.currentline]=="[Top level]") or (os.path.isdir(files.dirlist[files.currentline]) ) ):
					# not a dir, not top level, not .., so preview
					read=pygame.image.load(files.dirlist[files.currentline])
					if read.get_width()>read.get_height():
							ratio=200/read.get_width()
					else:
							ratio=200/read.get_height()
					read=pygame.transform.scale(read, (read.get_width()*ratio,read.get_height()*ratio))
					screen.blit(read,(300-read.get_width(), (240-read.get_height())/2  ))
					pygame.display.flip()
				
			if (event.type == KEYUP and event.key==K_b) or (event.type == pygame.JOYBUTTONUP and  event.button == gp2x.BUTTON_SELECT):
					files.draw(screen)




if __name__ == '__main__':   main()
