from __future__ import division
import pygame, random
from pygame.locals import *

import gp2x


class Cursor:
	def __init__(self):
		self.across=0
		self.down=0

class Layout:
	def __init__(self,screen):
		self.text=""
		keyboardlines=["1234567890","QWERTYUIOP","ASDFGHJKL","ZXCVBNM_"]
		self.width=10  # must be width of widest keyboardline
        	self.grid = [[0 for x in range(0,self.width)] for y in range(0,len(keyboardlines)+1)]
		self.lengths=[0 for x in range(0,len(keyboardlines)+1)]

		# loop to fill array
		for line in range(0,len(keyboardlines)):
			self.lengths[line]=len(keyboardlines[line])
			for pos in range(0,len(keyboardlines[line])):
				self.grid[line][pos]=keyboardlines[line][pos]
		self.grid[len(self.grid)-1][0]="Del"
		self.grid[len(self.grid)-1][1]="Enter"
		self.lengths[len(self.grid)-1]=2

		# loop to draw initial image of keyboard
		for line in range(0,len(self.grid)):
			for pos in range(0,self.lengths[line]):
				xoffset=(160/2)-((14*self.lengths[line])/2)
				if line==len(self.grid)-1:
					msgsay(screen,self.grid[line][pos],18,grey1,(130+((pos)*30)),70+(line*14),"left") # del/enter
				else:					
					msgsay(screen,self.grid[line][pos],16,grey1,xoffset+(pos*14)+80,70+(line*14),"left") # chr
		drawmsgbox(screen,150,20,85,150,grey2,white,2)	
		self.keyboardimage=screen.copy()

	def drawgrid(self,screen,cursorposition):
    		screen.blit(self.keyboardimage, (0,0))
		xoffset=(160/2)-((14*self.lengths[cursorposition.down])/2)

		if cursorposition.down==len(self.grid)-1:
			msgsay(screen,self.grid[cursorposition.down][cursorposition.across],18,red,(130+((cursorposition.across)*30)),70+(cursorposition.down*14),"left") # del/enter
		else:	
			msgsay(screen,self.grid[cursorposition.down][cursorposition.across],16,red,xoffset+(cursorposition.across*14)+80,70+(cursorposition.down*14),"left") # chr

		msgsay(screen,self.text,15,black,92,152,"left")
   		pygame.display.flip()		



def msgsay(screen,text,fontsize,colour,x,y,justify):
        font = pygame.font.Font(None, fontsize)
        text = font.render(text, 0, colour)
       	textpos = text.get_rect()
	if justify=="right":
		textpos.topright = (x,y)
	else:
		textpos.topleft = (x,y)
	screen.blit(text, textpos)	


def drawmsgbox(screen,wide,high,x,y,col1,col2,border):
	back=pygame.Surface((wide,high))
	back=back.convert()
	back.fill(col1)
	screen.blit(back, (x,y))
	if wide>1 and high>1:
		back=pygame.Surface((wide-(border*2),high-(border*2)))
		back=back.convert()
		back.fill(col2)
		screen.blit(back, (x+border,y+border))	
			




def main(screencopy):


#def main():

    pygame.init()
 #   pygame.mouse.set_visible(0)


    num_joysticks = pygame.joystick.get_count()
    if num_joysticks > 0:
    	stick = pygame.joystick.Joystick(0)
    	stick.init() # now we will receive events for the joystick


 
    pygame.mouse.set_cursor(*pygame.cursors.broken_x)
 
    global red,green,blue,white,black,grey1,grey2,grey3
    white = (255, 255, 255)
    black = (0, 0, 0)
    red = (255,0,0)
    green = (0,255,0)
    blue = (0,0,255)
    grey1= (63,63,63)
    grey2 = (127,127,127)
    grey3 = (191,191,191)

    size = width, height = 320,240
    screen = pygame.display.set_mode(size)

    cursorposition=Cursor()

    my_picture = pygame.Surface((160,120))
    my_picture = my_picture.convert()
    my_picture.fill(grey3)
    
    screen.blit(screencopy,(0,0))   # cheat to make it look like this screen is drawn on top of the calling screen

    screen.blit(my_picture, (80,60))
    pygame.display.flip()
    clock = pygame.time.Clock()
    keyboard=Layout(screen)
    keyboard.drawgrid(screen,cursorposition)
    while 1:
    
	for event in pygame.event.get():
		pressed_keys = pygame.key.get_pressed() 
		if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE ):
 		          return "[ABORT]"
		if (event.type == KEYDOWN and (pressed_keys[K_LEFT] or pressed_keys[K_RIGHT] or pressed_keys[K_DOWN] or pressed_keys[K_UP])) or (event.type == pygame.JOYBUTTONDOWN and (event.button == gp2x.BUTTON_UP or event.button == gp2x.BUTTON_DOWN or event.button == gp2x.BUTTON_LEFT or event.button == gp2x.BUTTON_RIGHT)) :
			if (event.type == KEYDOWN and pressed_keys[K_UP]) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_UP):
				if cursorposition.down>0:
					# move across value over 4 or so if moving up from bottom line, to make it look more even
					if cursorposition.down==len(keyboard.grid)-1:
						cursorposition.across+=3

					cursorposition.down += -1
					if cursorposition.across>keyboard.lengths[cursorposition.down]-1:
						cursorposition.across=keyboard.lengths[cursorposition.down]-1
			if (event.type == KEYDOWN and pressed_keys[K_DOWN]) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_DOWN): 
				if cursorposition.down<len(keyboard.grid)-1:
					cursorposition.down += 1
					if cursorposition.across>keyboard.lengths[cursorposition.down]-1:
						cursorposition.across=keyboard.lengths[cursorposition.down]-1
			if (event.type == KEYDOWN and pressed_keys[K_LEFT]) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_LEFT):
				if cursorposition.across>0:
					cursorposition.across += -1
			if (event.type == KEYDOWN and pressed_keys[K_RIGHT]) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_RIGHT):
				if cursorposition.across<keyboard.lengths[cursorposition.down]-1:
					cursorposition.across += 1

			keyboard.drawgrid(screen,cursorposition)

		if (event.type == KEYDOWN and event.key==K_SPACE) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_B):
			if keyboard.grid[cursorposition.down][cursorposition.across]=="Enter":
				return keyboard.text
			elif keyboard.grid[cursorposition.down][cursorposition.across]=="Del":
				keyboard.text=keyboard.text[0:len(keyboard.text)-1]
			else:
				if len(keyboard.text)<20:   # limit entry to 20 characters
					keyboard.text+=keyboard.grid[cursorposition.down][cursorposition.across]
			keyboard.drawgrid(screen,cursorposition)
					
		if (event.type == KEYDOWN and event.key==K_x) or (event.type == pygame.JOYBUTTONDOWN and  event.button == gp2x.BUTTON_START):
			return "[ABORT]"
			
			
#if __name__ == '__main__':   main()


if __name__ == '__main__':   main(screencopy)
