from __future__ import division
import pygame, random
from pygame.locals import *

import os
import gp2x
import onscreenkeyboard
import directorybrowser


class Brush:
	def __init__(self):
    		self.colours=[black,white,red,green,blue,(255,255,0),(0,255,255),(255,0,255),(128,0,0),(0,128,0),(0,0,128),(128,0,128),(128,128,0),(0,128,128),(128,128,128),(192,192,192)]
		self.shapetoollist=["rectangle","circle","ellipse","line","filledrectangle","filledcircle","filledellipse"]
		self.colourindex=0
		self.shapetoolindex=0
		self.shapeoriginx=0
		self.shapeoriginy=0
		self.filemenuindex=0
		self.shapes=["square","circle","circle","circle","circle","square","square","square"]
		self.sizes=[1,2,4,7,10,4,8,16]
		self.shapeindex=2  # identifies position in brush shapes list
		self.filemenulist=["New","Load","Save","Quit"]
		self.filemenuindex=0
		self.BORDER_COLOR=black
		self.undolist=[]
	def addundo(self,screen):
		if len(self.undolist)>9:
			del self.undolist[0]
		self.undolist.append(screen)
	def undo(self,screen):
		if len(self.undolist)>0:
			screen.blit(self.undolist.pop(),(0,0))
			pygame.display.flip()


class Menu:
	def __init__(self,screen,mybrush):
		self.startdir=os.getcwd()

		self.headings=["File","Pens","Colours","Shapes","Speed"]
		self.option=1		# self.headings option to show when menu loads
		self.headimage=pygame.Surface((320,30))
		self.headimage = self.headimage.convert()
		self.headimage.fill(grey3)
		self.lastdrawmode=0
		self.fillimage=pygame.image.load("system/fill.png")
		self.fillimage.convert()
		self.shapesimage=pygame.image.load("system/shapes.png")
		self.shapesimage.convert()
		self.shapeslist=pygame.image.load("system/shapes2.png")
		self.shapeslist.convert()
		self.diskimage=pygame.image.load("system/disk.png")
		self.diskimage.convert()
		self.exit=0
		self.quit=0
		os.chdir(self.startdir+"/saves")


	def showmenu(self,screen,mybrush,point):
		self.headimage.fill(grey3)

		# draw red square on top bar to show we're on this option
		drawmsgbox(self.headimage,34,26,4+(self.option*35),2,blue,blue,0)


		for opt in range(0,len(self.headings)):
			if self.headings[opt]=="Colours":
				drawmsgbox(self.headimage,32,24,5+(opt*35),3,black,mybrush.colours[mybrush.colourindex],1)	
				if mybrush.colours[mybrush.colourindex]==black:
					drawmsgbox(self.headimage,30,22,6+(opt*35),4,white,black,1)	
					
			if self.headings[opt]=="Pens":
				drawmsgbox(self.headimage,32,24,5+(opt*35),3,black,white,1)
				if mybrush.shapes[mybrush.shapeindex]=="circle":
					pygame.draw.circle(self.headimage, black, (21+(opt*35),15), mybrush.sizes[mybrush.shapeindex], 0)
				if mybrush.shapes[mybrush.shapeindex]=="square":
					drawmsgbox(self.headimage,mybrush.sizes[mybrush.shapeindex],mybrush.sizes[mybrush.shapeindex],((20-mybrush.sizes[mybrush.shapeindex])/2)+12+(opt*35),((16-mybrush.sizes[mybrush.shapeindex])/2)+7,black,black,0)

			if self.headings[opt]=="Shapes":
				drawmsgbox(self.headimage,32,24,5+(opt*35),3,black,white,1)
				self.headimage.blit(self.shapesimage,(6+(opt*35),4))

			if self.headings[opt]=="Fill":
				drawmsgbox(self.headimage,32,24,5+(opt*35),3,black,white,1)
				self.headimage.blit(self.fillimage,(6+(opt*35),4))

			if self.headings[opt]=="File":
				drawmsgbox(self.headimage,32,24,5+(opt*35),3,black,white,1)
				self.headimage.blit(self.diskimage,(6+(opt*35),4))



			if self.headings[opt]=="Speed":
				drawmsgbox(self.headimage,32,24,5+(opt*35),3,black,white,1)
				drawmsgbox(self.headimage,30,int(2.2*point.speed),6+(opt*35),26-int(2.2*point.speed),red,red,0)
				msgsay(self.headimage,str(point.speed),28,black,30+(opt*35),3,"right")


		screen.blit(self.headimage,(0,0))
		pygame.display.flip()

	def colourpopup(self,screen,mybrush):
		drawmsgbox(screen,42,5+(11*len(mybrush.colours)),(self.option*35),30,grey3,grey3,0)
		for col in range(0,len(mybrush.colours)):
			if mybrush.colourindex==col:
				drawmsgbox(screen,40,12,1+(self.option*35),30+(col*11),blue,blue,0)
			drawmsgbox(screen,32,12,5+(self.option*35),30+(col*11),black,mybrush.colours[col],1)
	
		

	def penpopup(self,screen,mybrush):
		drawmsgbox(screen,42,5+(23*len(mybrush.shapes)),(self.option*35),30,grey3,grey3,0)
		for col in range(0,len(mybrush.shapes)):
			if mybrush.shapeindex==col:
				drawmsgbox(screen,40,24,1+(self.option*35),30+(col*23),blue,blue,0)
			drawmsgbox(screen,32,24,5+(self.option*35),30+(col*23),black,white,1)
			if mybrush.shapes[col]=="circle":
				pygame.draw.circle(screen, black, (21+(self.option*35),42+(col*23)), mybrush.sizes[col], 0)
			if mybrush.shapes[col]=="square":
				drawmsgbox(screen,mybrush.sizes[col],mybrush.sizes[col],10+(self.option*35)+11-(mybrush.sizes[col]/2),26+(24*col)+15-(mybrush.sizes[col]),black,black,0)

	def shapespopup(self,screen,mybrush):
		drawmsgbox(screen,42,5+(23*7),(self.option*35),30,grey3,grey3,0)
		drawmsgbox(screen,40,24,1+(self.option*35),30+(mybrush.shapetoolindex*23),blue,blue,0)		
		screen.blit(self.shapeslist,(5+(self.option*35),30))


	def filepopup(self,screen,mybrush):
		drawmsgbox(screen,42,5+(23*len(mybrush.filemenulist)),(self.option*35),30,grey3,grey3,0)
		for col in range(0,len(mybrush.filemenulist)):
			if mybrush.filemenuindex==col:
				drawmsgbox(screen,40,24,1+(self.option*35),30+(col*23),blue,blue,0) # menu highlight
			drawmsgbox(screen,32,24,5+(self.option*35),30+(col*23),black,white,1)   # option box
			msgsay(screen,mybrush.filemenulist[col],16,black,7+(self.option*35),35+(col*23),"left")

	def showcurrentpopup(self,screen,mybrush,point):
		# pop up currently selected menu option
		if self.headings[self.option]=="Colours":
			self.colourpopup(screen,mybrush)
		if self.headings[self.option]=="File":
			self.filepopup(screen,mybrush)
		if self.headings[self.option]=="Pens":
			self.lastdrawmode=self.option
			self.penpopup(screen,mybrush)
		if self.headings[self.option]=="Shapes":
			self.lastdrawmode=self.option 
			self.shapespopup(screen,mybrush)

		msgsay(screen,self.headings[self.option],24,grey1,310,5,"right")
	
		pygame.display.flip()		


def menuloop(screen,gamemenu,mybrush,point):

	gamemenu.showmenu(screen,mybrush,point)
	savemenu=screen.copy()


	gamemenu.showcurrentpopup(screen,mybrush,point)	

	while 1:
		for event in pygame.event.get():
			pressed_keys = pygame.key.get_pressed() 
			if (event.type == KEYUP and event.key==K_p) or (event.type == pygame.JOYBUTTONUP and (event.button==gp2x.BUTTON_L or event.button==gp2x.BUTTON_R)):
				if gamemenu.headings[gamemenu.option]=="File":
					gamemenu.exit=mybrush.filemenulist[mybrush.filemenuindex]
				gamemenu.option=gamemenu.lastdrawmode
				return
			if (event.type == KEYDOWN and pressed_keys[K_UP]) or (event.type == pygame.JOYBUTTONDOWN and event.button==gp2x.BUTTON_UP): 
				if gamemenu.headings[gamemenu.option]=="Colours":
					if mybrush.colourindex>0:
						mybrush.colourindex-=1
						gamemenu.showmenu(screen,mybrush,point)
				if gamemenu.headings[gamemenu.option]=="Pens":
					if mybrush.shapeindex>0:
						mybrush.shapeindex += -1
						gamemenu.showmenu(screen,mybrush,point)
				if gamemenu.headings[gamemenu.option]=="Speed":
					if point.speed<10:
						point.speed += 1
						gamemenu.showmenu(screen,mybrush,point)
				if gamemenu.headings[gamemenu.option]=="Shapes":
					if mybrush.shapetoolindex>0:
						mybrush.shapetoolindex += -1
						gamemenu.showmenu(screen,mybrush,point)
				if gamemenu.headings[gamemenu.option]=="File":
					if mybrush.filemenuindex>0:
						mybrush.filemenuindex += -1
						gamemenu.showmenu(screen,mybrush,point)
	
			if (event.type == KEYDOWN and pressed_keys[K_DOWN]) or  (event.type == pygame.JOYBUTTONDOWN and event.button==gp2x.BUTTON_DOWN): 
				if gamemenu.headings[gamemenu.option]=="Colours":
					if mybrush.colourindex<(len(mybrush.colours)-1):
						mybrush.colourindex += 1
						gamemenu.showmenu(screen,mybrush,point)
				if gamemenu.headings[gamemenu.option]=="Pens":
					if mybrush.shapeindex<(len(mybrush.shapes)-1):
						mybrush.shapeindex += 1
						gamemenu.showmenu(screen,mybrush,point)
						
				if gamemenu.headings[gamemenu.option]=="Speed":
					if point.speed>1:
						point.speed += -1
						gamemenu.showmenu(screen,mybrush,point)

				if gamemenu.headings[gamemenu.option]=="Shapes":
					if mybrush.shapetoolindex<len(mybrush.shapetoollist)-1:
						mybrush.shapetoolindex += 1
						gamemenu.showmenu(screen,mybrush,point)
				if gamemenu.headings[gamemenu.option]=="File":
					if mybrush.filemenuindex<len(mybrush.filemenulist)-1:
						mybrush.filemenuindex += 1
						gamemenu.showmenu(screen,mybrush,point)

			if (event.type == KEYDOWN and pressed_keys[K_LEFT]) or  (event.type == pygame.JOYBUTTONDOWN and event.button==gp2x.BUTTON_LEFT): 
				if gamemenu.option>0:
					gamemenu.option += -1
					screen.blit(savemenu,(0,0))
					gamemenu.showmenu(screen,mybrush,point)

				
			if (event.type == KEYDOWN and pressed_keys[K_RIGHT]) or  (event.type == pygame.JOYBUTTONDOWN and event.button==gp2x.BUTTON_RIGHT): 
				if gamemenu.option<len(gamemenu.headings)-1:
					gamemenu.option += 1
					screen.blit(savemenu,(0,0))
					gamemenu.showmenu(screen,mybrush,point)
			gamemenu.showcurrentpopup(screen,mybrush,point)


class Arrow:
    def __init__(self):
	self.hasinertia=1
	self.speed=4
        self.inertia = 0
	self.drawinertia = 0
        self.across=160
        self.down=120      
        self.direction=across,down=0,0
        pygame.mouse.set_pos(160,120)

    def move(self):
        x,y=self.direction

        if (self.down<1 and y==-1) or (self.down>240 and y==1):
            y=0
	    
	    #self.drawinertia=0
	    #self.inertia=0
            
        if (self.across<1 and x==-1) or (self.across>320 and x==1):
            #self.drawinertia=0
	    #self.inertia=0
            x=0

	if self.hasinertia==1:
		step=self.speed/abs(self.speed-11)
	else:
		step=self.speed
	self.across=self.across+(x*step)	
	self.down=self.down+(y*step)	
        pygame.mouse.set_pos(self.across,self.down)

    def inertiastate(self,screen):
	grab=screen.copy()
	drawmsgbox(screen,120,30,200,0,grey3,grey3,0)
	if self.hasinertia==0:
		msgsay(screen,"Inertia OFF",24,grey1,310,5,"right")
	else:
		msgsay(screen,"Inertia ON",24,grey1,310,5,"right")
	pygame.display.flip()

	pygame.time.wait(500)
	screen.blit(grab,(0,0))
	pygame.display.flip()


    def savedmessage(self,screen):
	grab=screen.copy()
	drawmsgbox(screen,320,30,0,100,grey3,grey3,0)
	msgsay(screen,"Image saved",24,grey1,50,105,"left")
	pygame.display.flip()

	pygame.time.wait(2000)
	screen.blit(grab,(0,0))
	pygame.display.flip()

def msgsay(screen,text,fontsize,colour,x,y,justify):
        font = pygame.font.Font(None, fontsize)
        text = font.render(text, 0, colour)
       	textpos = text.get_rect()
	if justify=="right":
		textpos.topright = (x,y)
	else:
		textpos.topleft = (x,y)
	screen.blit(text, textpos)	


def drawmsgbox(screen,wide,high,x,y,col1,col2,border):
	back=pygame.Surface((wide,high))
	back=back.convert()
	back.fill(col1)
	screen.blit(back, (x,y))
	if wide>1 and high>1:
		back=pygame.Surface((wide-(border*2),high-(border*2)))
		back=back.convert()
		back.fill(col2)
		screen.blit(back, (x+border,y+border))	
			

def showcontrols(screen,gamemenu):
	pygame.mouse.set_visible(0)
	controls=pygame.image.load(gamemenu.startdir+"/system/controls.png")
	controls.convert()
	screen.blit(controls,(0,0))
	pygame.display.flip()
	while 1:
		for event in pygame.event.get():
			pressed_keys = pygame.key.get_pressed() 
			if (event.type == pygame.JOYBUTTONUP and event.button == gp2x.BUTTON_START) or (event.type==KEYUP and event.key==K_h):
					pygame.mouse.set_visible(1)
					return
	
	
	
def menupress(screen,mybrush,gamemenu,point,clock):
		point.inertia=0
		point.drawinertia=0
		mybrush.screenback=screen.copy()
		menuloop(screen,gamemenu,mybrush,point)
		clock.tick(5)
		screen.blit(mybrush.screenback, (0, 0))
		pygame.display.flip()
		if gamemenu.exit=="Quit":
				gamemenu.quit=1
				return 0	
		elif gamemenu.exit=="Save":
				restore=screen.copy()
				gettext=onscreenkeyboard.main(restore)
				screen.blit(restore,(0,0))
				pygame.display.flip()
				if not gettext=="[ABORT]":
						savefile=gamemenu.startdir+"/saves/"+gettext+".bmp" 
						pygame.image.save(screen,savefile)
						os.system("/bin/sync")
						point.savedmessage(screen)
		elif gamemenu.exit=="New":
				mybrush.addundo(mybrush.screenback)
				screen.fill(white)
				pygame.display.flip()
		elif gamemenu.exit=="Load":
				mybrush.addundo(mybrush.screenback)
				loadfile=directorybrowser.main()
				if loadfile=="NOTHING":
					screen.blit(mybrush.screenback, (0, 0))				
					pygame.display.flip()
				else:
						screen.fill(white)
						read=pygame.image.load(loadfile)
						if read.get_width()>320 or read.get_height()>240:
							# then we want to resize it
							ratio=1
							if read.get_width()>read.get_height():
								ratio=320/read.get_width()
							else:
								ratio=240/read.get_height()
							read=pygame.transform.scale(read, (read.get_width()*ratio,read.get_height()*ratio))
						screen.blit(read,( (320-read.get_width())/2 , (240-read.get_height())/2 ) )
						pygame.display.flip()
		gamemenu.exit=""
		mybrush.filemenuindex=0


def drawshapes(screen,point,mybrush):
				
					# make lines width circle diameter not radius, or square width
					if mybrush.shapetoollist[mybrush.shapetoolindex].find("filled")>-1:
						linewidth=0   # fill shapes if current shape is a filled one
					else:
						if mybrush.shapes[mybrush.shapeindex]=="square":
							linewidth=mybrush.sizes[mybrush.shapeindex]
						else:
							linewidth=mybrush.sizes[mybrush.shapeindex]*2				
	
					# draw temp shape on backup copy of screen
					screen.blit(mybrush.shapetoolbackup,(0,0))
		
					if mybrush.shapetoollist[mybrush.shapetoolindex].find("rectangle")>-1:
						pygame.draw.rect(screen,mybrush.colours[mybrush.colourindex],(mybrush.shapeoriginx,mybrush.shapeoriginy,point.across-mybrush.shapeoriginx,point.down-mybrush.shapeoriginy ),linewidth)
					elif mybrush.shapetoollist[mybrush.shapetoolindex].find("line")>-1:
						pygame.draw.line(screen,mybrush.colours[mybrush.colourindex],(mybrush.shapeoriginx,mybrush.shapeoriginy),(point.across,point.down),linewidth)
					elif mybrush.shapetoollist[mybrush.shapetoolindex].find("ellipse")>-1:
						myrect=pygame.rect=(mybrush.shapeoriginx,mybrush.shapeoriginy,point.across-mybrush.shapeoriginx,point.down-mybrush.shapeoriginy)
						if point.across-mybrush.shapeoriginx>0:
							topx=mybrush.shapeoriginx
							shapewidth=point.across-mybrush.shapeoriginx
						else:
							topx=point.across
							shapewidth=mybrush.shapeoriginx-point.across

						if point.down-mybrush.shapeoriginy>0:
							topy=mybrush.shapeoriginy
							shapeheight=point.down-mybrush.shapeoriginy
						else:
							topy=point.down
							shapeheight=mybrush.shapeoriginy-point.down
						if shapewidth>linewidth*2 and shapeheight>linewidth*2: # only draw ellipse if it's big enough to allow the line width thickness
							pygame.draw.ellipse(screen,mybrush.colours[mybrush.colourindex],(topx,topy,shapewidth,shapeheight),linewidth)
					elif mybrush.shapetoollist[mybrush.shapetoolindex].find("circle")>-1:
						# pygame.draw.rect(screen,mybrush.colours[mybrush.colourindex],(mybrush.shapeoriginx,mybrush.shapeoriginy,point.across-mybrush.shapeoriginx,point.down-mybrush.shapeoriginy),linewidth)

						if abs(mybrush.shapeoriginx-point.across)>linewidth:
							pygame.draw.circle(screen, mybrush.colours[mybrush.colourindex], (mybrush.shapeoriginx,mybrush.shapeoriginy), abs(mybrush.shapeoriginx-point.across), linewidth)







def main():
    pygame.init()
 #   pygame.mouse.set_visible(0)


    num_joysticks = pygame.joystick.get_count()
    if num_joysticks > 0:
    	stick = pygame.joystick.Joystick(0)
    	stick.init() # now we will receive events for the joystick

    pygame.mouse.set_cursor(*pygame.cursors.broken_x)
 
    global red,green,blue,white,black,grey1,grey2,grey3
    white = (255, 255, 255)
    black = (0, 0, 0)
    red = (255,0,0)
    green = (0,255,0)
    blue = (0,0,255)
    grey1= (63,63,63)
    grey2 = (127,127,127)
    grey3 = (191,191,191)
    size = width, height = 320, 240 
    screen = pygame.display.set_mode((320,240))
    pygame.display.set_caption('pyBrush')

    my_picture = pygame.Surface(screen.get_size())
    my_picture = my_picture.convert()
    my_picture.fill(white)
    
    clock = pygame.time.Clock()
    screen.blit(my_picture, (0, 0))
    pygame.display.flip()
    point=Arrow()
    mybrush=Brush()
    gamemenu=Menu(screen,mybrush)


    while 1:
    

    
	for event in pygame.event.get():
		if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE ):
 		          return
		pressed_keys = pygame.key.get_pressed() 

		##### JOYSTICK EVENTS #####

		if event.type == pygame.JOYBUTTONUP:
			if event.button < 8:  # if they released any direction
				# reset inertia if they're now not holding a direction, or keep it if another direction is pressed
				if stick.get_button(0) or stick.get_button(1) or stick.get_button(2) or stick.get_button(3) or stick.get_button(4) or stick.get_button(5) or stick.get_button(6) or stick.get_button(7):
					point.inertia=1
				else:
					point.inertia=0
			if event.button==gp2x.BUTTON_B:
				point.drawinertia=0
				if gamemenu.headings[gamemenu.option]=="Shapes":
					drawshapes(screen,point,mybrush)

		if event.type == pygame.JOYBUTTONDOWN:
			if event.button < 8: # so is a direction of some sort
				point.inertia=1
				if event.button == gp2x.BUTTON_UP:
					point.direction=(0,-1)
				if event.button == gp2x.BUTTON_DOWN: 
					point.direction=(0,1)
				if event.button == gp2x.BUTTON_LEFT:
					point.direction=(-1,0)
				if event.button == gp2x.BUTTON_RIGHT:
					point.direction=(1,0)
				if event.button == gp2x.BUTTON_UPLEFT:
					point.direction=(-1,-1)
				if event.button == gp2x.BUTTON_DOWNLEFT: 
					point.direction=(-1,1)
				if event.button == gp2x.BUTTON_UPRIGHT:
					point.direction=(1,-1)
				if event.button == gp2x.BUTTON_DOWNRIGHT:
					point.direction=(1,1)

			if event.button == gp2x.BUTTON_B:
				mybrush.addundo(screen.copy())
				point.drawinertia=1
				if gamemenu.headings[gamemenu.option]=="Shapes":
					mybrush.shapetoolbackup=screen.copy()
					mybrush.shapeoriginx=point.across
					mybrush.shapeoriginy=point.down


			if event.button == gp2x.BUTTON_SELECT:
				mybrush.undo(screen)


			if event.button == gp2x.BUTTON_START:
				restore=screen.copy()
   				showcontrols(screen,gamemenu)
				screen.blit(restore,(0,0))
				pygame.display.flip()


			if event.button == gp2x.BUTTON_Y:
				if point.hasinertia==1:
					point.hasinertia=0
				else:
					point.hasinertia=1
				point.inertiastate(screen)
			if event.button == gp2x.BUTTON_L or event.button == gp2x.BUTTON_R:
				menupress(screen,mybrush,gamemenu,point,clock)
				if gamemenu.quit==1:
					return 0
					
		##### END OF JOYSTICK EVENTS #####


		##### KEYBOARD EVENTS  - ONLY HERE FOR DEVELOPMENT - MOSTLY BEHIND GP2x OR FOR TESTING#####
		if event.type == KEYDOWN:
			if pressed_keys[K_q]:
				return 0
	                if pressed_keys[K_LEFT] or pressed_keys[K_RIGHT] or pressed_keys[K_DOWN] or pressed_keys[K_UP] :
				point.inertia=1
				if pressed_keys[K_UP]:
					point.direction=(0,-1)
				if pressed_keys[K_DOWN]: 
					point.direction=(0,1)
				if pressed_keys[K_LEFT]:
					point.direction=(-1,0)
				if pressed_keys[K_RIGHT]:
					point.direction=(1,0)
				if pressed_keys[K_UP] and pressed_keys[K_LEFT]:
					point.direction=(1,1)

			if event.key==K_h:
				restore=screen.copy()
   				showcontrols(screen,gamemenu)
				screen.blit(restore,(0,0))
				pygame.display.flip()


			if pressed_keys[K_u]:
				mybrush.undo(screen)

			if event.key==K_SPACE:
				mybrush.addundo(screen.copy())
				point.drawinertia=1
				if gamemenu.headings[gamemenu.option]=="Shapes":
					mybrush.shapetoolbackup=screen.copy()
					mybrush.shapeoriginx=point.across
					mybrush.shapeoriginy=point.down

			if pressed_keys[K_p]:
				menupress(screen,mybrush,gamemenu,point,clock)
				if gamemenu.quit==1:
					return 0
			
			if pressed_keys[K_m]:
				if point.hasinertia==1:
					point.hasinertia=0
				else:
					point.hasinertia=1
				point.inertiastate(screen)

		if event.type == KEYUP:
			if event.key==K_LEFT or event.key==K_RIGHT or event.key==K_DOWN or event.key==K_UP :
				point.inertia=0 
			if event.key==K_SPACE:
				point.drawinertia=0
				if gamemenu.headings[gamemenu.option]=="Shapes":
						drawshapes(screen,point,mybrush)
					

		##### END OF KEYBOARD EVENTS #####
	






	if point.drawinertia==1:
		if gamemenu.headings[gamemenu.option]=="Shapes":
			drawshapes(screen,point,mybrush)
		else:
			if mybrush.shapes[mybrush.shapeindex]=="circle":
				pygame.draw.circle(screen, mybrush.colours[mybrush.colourindex], (point.across,point.down), mybrush.sizes[mybrush.shapeindex], 0)
			if mybrush.shapes[mybrush.shapeindex]=="square":
				drawmsgbox(screen,mybrush.sizes[mybrush.shapeindex],mybrush.sizes[mybrush.shapeindex],1+point.across-int(mybrush.sizes[mybrush.shapeindex]/2),1+point.down-int(mybrush.sizes[mybrush.shapeindex]/2),mybrush.colours[mybrush.colourindex],mybrush.colours[mybrush.colourindex],1)

	pygame.display.flip()
 
	if point.inertia==1:
		pygame.mouse.set_visible(0)
		point.move()
		pygame.mouse.set_visible(1)
		if point.hasinertia==0:
			point.inertia=0

if __name__ == '__main__':   main()


